//---------------------------------------------------------------------------
//
// Name:        TextGameFrm.cpp
// Author:      Kirill
// Created:     18.08.2009 11:42:01
// Description: TextGameFrm class implementation
//
//---------------------------------------------------------------------------

#include "TextGameFrm.h"
#include "UseItemDlg.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
#include "Images/Self_TextGameFrm_XPM.xpm"
////Header Include End

int max=11;//the number of rooms and characters and items in the bag - equal for all
int room[11];
int current_room=5;
int border_left=3;//borders of the game
int border_right=8;//so you can't go left and right when there is nothing there

bool character_exists=false;//a flag that tells whether there are any characters in the room
bool item_taken=false;//a flag that tells whether any item was taken
int action_flag[2][2];
//a flag that tells whether you are blocked in any direction or can be killed when going in any direction
//action_flag[0][0] - left direction action type
//action_flag[0][1] - left direction action id
//action_flag[1] - right direction action type
//action_flag[1][1] - right direction action id

bool dead=false;

int events[11];//list of ongoing events
int parameter1;
int parameter2;
int parameter3;

wxString room_title[11];
wxString room_info[11];
wxString room_directions[11];
wxString character[11][4];
//character[x][0] - room number in which the character exists
//character[x][1] - description of character
//character[x][2] - type of character: 0 for collectable thing, 1 for living creature
//character[x][3] - short name of character


wxString action[11][2];
//action[x][0] - severity of action - none 0, kill left 1, kill right 2, block left 3, block right 4;
//action[x][1] - text of action

int bag[11];
wxString item_chosen;//which item was chosen

//----------------------------------------------------------------------------
// TextGameFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(TextGameFrm,wxFrame)
	////Manual Code Start
	EVT_KEY_DOWN(TextGameFrm::OnKeyDown)
	////Manual Code End
	
	EVT_CLOSE(TextGameFrm::OnClose)
	EVT_BUTTON(ID_RIGHTBUTTON,TextGameFrm::RightButtonClick)
	EVT_BUTTON(ID_DROPBUTTON,TextGameFrm::DropButtonClick)
	EVT_BUTTON(ID_TAKEBUTTON,TextGameFrm::TakeButtonClick)
	EVT_BUTTON(ID_USEBUTTON,TextGameFrm::NothingButtonClick)
	EVT_BUTTON(ID_LEFTBUTTON,TextGameFrm::LeftButtonClick)
END_EVENT_TABLE()
////Event Table End

TextGameFrm::TextGameFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

TextGameFrm::~TextGameFrm()
{
}

void TextGameFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxToolBar1 = new wxToolBar(this, ID_WXTOOLBAR1, wxPoint(0,0), wxSize(403,24));
	WxToolBar1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	LeftButton = new wxButton(WxToolBar1, ID_LEFTBUTTON, wxT("<"), wxPoint(0,0), wxSize(22,22), 0, wxDefaultValidator, wxT("LeftButton"));
	LeftButton->Enable(false);
	LeftButton->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxToolBar1->AddControl(LeftButton);

	UseButton = new wxButton(WxToolBar1, ID_USEBUTTON, wxT("Use item"), wxPoint(22,0), wxSize(75,22), 0, wxDefaultValidator, wxT("UseButton"));
	UseButton->Enable(false);
	UseButton->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxToolBar1->AddControl(UseButton);

	TakeButton = new wxButton(WxToolBar1, ID_TAKEBUTTON, wxT("Take item"), wxPoint(97,0), wxSize(75,22), 0, wxDefaultValidator, wxT("TakeButton"));
	TakeButton->Enable(false);
	TakeButton->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxToolBar1->AddControl(TakeButton);

	DropButton = new wxButton(WxToolBar1, ID_DROPBUTTON, wxT("Drop item"), wxPoint(172,0), wxSize(75,22), 0, wxDefaultValidator, wxT("DropButton"));
	DropButton->Enable(false);
	DropButton->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxToolBar1->AddControl(DropButton);

	RightButton = new wxButton(WxToolBar1, ID_RIGHTBUTTON, wxT(">"), wxPoint(247,0), wxSize(22,22), 0, wxDefaultValidator, wxT("RightButton"));
	RightButton->Enable(false);
	RightButton->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxToolBar1->AddControl(RightButton);

	WxStatusBar1 = new wxStatusBar(this, ID_WXSTATUSBAR1);
	WxStatusBar1->SetFieldsCount(1);
	WxStatusBar1->SetStatusText(wxT(""),0);
	int WxStatusBar1_Widths[1];
	WxStatusBar1_Widths[0] = -1;
	WxStatusBar1->SetStatusWidths(1,WxStatusBar1_Widths);

	Screen = new wxRichTextCtrl(this, ID_SCREEN, wxT(""), wxPoint(94,83), wxSize(185,89), 0 );
	Screen->SetMaxLength(0);
	Screen->AppendText(wxT("Welcome to... um... Text Game!"));
	Screen->AppendText(wxT("\n\n"));
	Screen->AppendText(wxT("To read up rules and keyboard "));
	Screen->AppendText(wxT("control, just press 'R'."));
	Screen->AppendText(wxT("\n\n\n\n"));
	Screen->AppendText(wxT("To start adventure, please "));
	Screen->AppendText(wxT("extend "));
	Screen->AppendText(wxT("your finger and press the 'Enter' "));
	Screen->AppendText(wxT("key."));
	Screen->AppendText(wxT("\n\n"));
	Screen->AppendText(wxT("Notice: if your keyboard does not "));
	Screen->AppendText(wxT("have the Enter key, you can "));
	Screen->AppendText(wxT("press "));
	Screen->AppendText(wxT("Space. It won't work but at least "));
	Screen->AppendText(wxT("you'll know you tried."));
	Screen->SetFocus();
	Screen->SetInsertionPointEnd();
	Screen->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	SetStatusBar(WxStatusBar1);
	WxToolBar1->Realize();
	SetToolBar(WxToolBar1);
	SetTitle(wxT("TextGame"));
	SetIcon(Self_TextGameFrm_XPM);
	SetSize(8,8,411,370);
	Center();
	
	////GUI Items Creation End
	
	
	this->ConnectKeyDownEvent(this);

    Screen->Clear();
    Screen->AppendText("Welcome to... um... Text Game!");
    Screen->AppendText("\n\nTo read up rules and keyboard control, just press 'R'.");
    Screen->AppendText("\n\n\n\nTo start adventure, please extend your finger and press the 'Enter' key.");
    Screen->BeginItalic();
    Screen->AppendText("\n\nNotice: if your keyboard does not have the Enter key, you can press Space. It won't work but at least you'll know you tried.");
    Screen->EndItalic();
	
	Screen->SetEditable(false);
	InitRooms();
	InitCharacters();
	events[0]=1;//dummy event
	
}

void TextGameFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


//////////
//KEYBOARD
//////////

//connecting all key down events
void TextGameFrm::ConnectKeyDownEvent(wxWindow* pclComponent)
{
  if(pclComponent)
  {
    pclComponent->Connect(wxID_ANY,
                          wxEVT_KEY_DOWN,
                          wxKeyEventHandler(TextGameFrm::OnKeyDown),
                          (wxObject*) NULL,
                          this);

    wxWindowListNode* pclNode = pclComponent->GetChildren().GetFirst();
    while(pclNode)
    {
      wxWindow* pclChild = pclNode->GetData();
      this->ConnectKeyDownEvent(pclChild);

      pclNode = pclNode->GetNext();
    }
  }
}


//processing key events
void TextGameFrm::OnKeyDown(wxKeyEvent& event){
    //getting key codes
    //Screen->WriteText(wxString::Format("%i",event.GetKeyCode()));
    
    if(event.GetKeyCode()==82){
    Screen->Clear();
    Screen->AppendText(wxT("Rules of the game are simple. Just read what's written and choose your action.\n"));
    Screen->AppendText(wxT("There are five things you can do in this game - go left, go right, take item, use item or drop item.\n"));
    Screen->AppendText(wxT("The game is not more than what it seems. At least, so it appears.\n\n"));
    Screen->AppendText(wxT("=Keyboard=\n"));
    Screen->AppendText(wxT("Enter- reset game\\start new game\n")); 
    Screen->AppendText(wxT("left and right arrows - go left and right\n"));
    Screen->AppendText(wxT("i - inventory\n"));
    Screen->AppendText(wxT("t - take item\n"));
    Screen->AppendText(wxT("u - use item\n"));
    Screen->AppendText(wxT("d - drop item\n"));
   
        }//R

    if(event.GetKeyCode()==73){
            SetRoom(current_room);
            
            if(BagIsEmpty()==true){Screen->AppendText("\n\nInventory:\nempty");}
            else{
                Screen->AppendText("\n\nInventory:\n");
                for(int i=0;i<max;i++){
                if(bag[i]!=0){
                Screen->AppendText(character[bag[i]][3]+"\n");
                }
            }
    }
        }//i
    
    if(event.GetKeyCode()==WXK_RETURN){//resetting game
        dead=false;
        events[0]=1;//resetting events
        current_room=5;//resetting current room number
        LeftButton->Enable(true);
        RightButton->Enable(true);
        UseButton->Enable(true);
        TakeButton->Enable(true);
        DropButton->Enable(true);
        InitRooms();//resetting room descriptions
        InitCharacters();//resetting all characters and actions
        EmptyBag();
        SetRoom(5);
        }   

    if(event.GetKeyCode()==85){
        UseItems();
        }//u

    if(event.GetKeyCode()==68){
        DropItems();
        }//d

    if(event.GetKeyCode()==84){
        FindCollectable(current_room);//find collectables, add them to the bag and remove from the room
            if(item_taken==true){
                    SetRoom(current_room);//reset the room
                    //Screen->AppendText("\n\nTaken!");
                    item_taken=false;
                    }
            else{SetRoom(current_room);Screen->AppendText("\n\nThere is nothing you can take here.");}        
        }//t
    
    if(event.GetKeyCode()==314 && dead==false){
	if(action_flag[0][0]==3){//if you are being blocked to the left
	    SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[0][1]][1]);
        //LeftButton->Enable(false);
        }
        else if(action_flag[0][0]==1){//if you were killed trying to go left
        SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[0][1]][1]);
        Death();
        }
        else if(border_left==current_room){//if there is nothing to the left
        }
	else{
    current_room--;
	SetRoom(current_room);
	}
        }//left

    if(event.GetKeyCode()==316 && dead==false){
	if(action_flag[1][0]==4){//if you are being blocked to the right
	    SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[1][1]][1]);
        //RightButton->Enable(false);
        }
        else if(action_flag[1][0]==2){//if you were killed trying to go right
        SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[1][1]][1]);
        Death();
        }
        else if(border_right==current_room){//if there is nothing to the right
        }
	else{
	current_room++;
	SetRoom(current_room);
    }
        }//right
    
}//keyboard events



//Set room
void TextGameFrm::SetRoom(int current_room){
        //resetting character and action flags
        action_flag[0][0]=0;
        action_flag[1][0]=0;
        character_exists=false;
        
        //SetEvent
        SetEvent(current_room);
    
        //creating basic room description
        Screen->Clear();
        Screen->BeginBold();
        Screen->AppendText(room_title[current_room]+"\n");        
        Screen->EndBold();
        Screen->WriteText(room_info[current_room]);
        
        //setting up room characters
        SetCharacter(current_room);
        
        Screen->WriteText("\n\n"+room_directions[current_room]);
        //Screen->WriteText("\n\n"+wxString::Format("%i",parameter1));
        
    }
    
//Set character
void TextGameFrm::SetCharacter(int current_room){
    
    int action_type;
        //finding characters which are in this room
        for(int i=0; i<max; i++){//sorting through all the available characters, in this version 11 items max
            
          if(character[i][0]==wxString::Format("%i",current_room)){
            Screen->AppendText("\n"+character[i][1]);//output character description
            character_exists=true;//marking that characters in this room exist
                
                action_type=wxAtoi(action[i][0]);
                //setting up room blocks and kills
                switch(action_type){
                case 0: break;
                case 1: action_flag[0][0]=1; action_flag[0][1]=i; break;
                case 2: action_flag[1][0]=2; action_flag[1][1]=i; break;
                case 3: action_flag[0][0]=3; action_flag[0][1]=i; break;
                case 4: action_flag[1][0]=4; action_flag[1][1]=i; break;
                }//switch
                
            }//if character is in this room

        }//going through the character array
        
    }//set character



//Set event
void TextGameFrm::SetEvent(int current_room){

             for(int i=0; i<max; i++){
             
                        switch(events[i]){
                            case 0:break;//no events
                            case 1:     //a dummy event that links the first actual event in the game
                                        //when the game starts the event is 1, otherwise the only way to trigger events would be
                                        //through taking items; a dummy event lets triggering events by visiting rooms
                                        if(current_room==7){events[0]=2;parameter1=1;}
                                        break;
                            case 2:     //making the witch follow the player
                                        if(current_room==6 && parameter1==1){//the yard
                                        character[4][0]=wxString::Format("%i",current_room);//whenever the player goes, she follows
                                        character[4][1]="Although you are cloaked, the witch must have suspected something, as she follows you outside. She sniffs the air.";
                                        action[4][0]="0";
                                        parameter1=2;//set the parameter to 2 which means you lef the house with the witch following you
                                        }
                                        else if(current_room==5 && parameter1==2){//the witch turns you into the rabbit
                                        character[4][0]=wxString::Format("%i",current_room);//whenever the player goes, she follows
                                        character[4][1]="Perhaps the witch is too experienced - your cloak did not help and the witch grabbed you. You tried to get away, but she whispered some spell and you became a rabbit.\n\n\nTo start over press 'Enter'.";//writing the start over text here since the Death() text append is overridden by the Clear() in the SetRoom()
                                        room_directions[5]="";
                                        Death();
                                        }
                                        else if(current_room==7 && parameter1==2){//if you left the house but then returned back to it
                                        room_info[7]="You rush back into the house and close the door!\n\nThe house is small and very untidy. A large pot stands in the center of a room with some ooze boiling inside it. It fills the air with very bad smell. Right above the pot, attached to the ceiling with ropes, hangs a whole bunch of stuff.";
                                        //fixing the witch description
                                        //character[4][1]="Although you are cloaked, the witch detects your presence. She sniffs the air.";
                                        character[4][1]="A witch stands by the pot and gives an occasinal stir to the ooze.";
                                        }
                                        else if(current_room==8 && parameter1==2){
                                        //fixing the room info back to normal when you go neat the pot
                                        room_info[7]="The house is small and very untidy. A large pot stands in the center of a room with some ooze boiling inside it. It fills the air with very bad smell. Right above the pot, attached to the ceiling with ropes, hangs a whole bunch of stuff.\n\nYou can hear the witch banging on the door.";    
                                        parameter1=3;//so that the previous condition does not happen
                                        }
                                        else if(current_room==6 && parameter1==3){
                                        
                                        room_info[7]="The house is small and very untidy. A large pot stands in the center of a room with some ooze boiling inside it. It fills the air with very bad smell. Right above the pot, attached to the ceiling with ropes, hangs a whole bunch of stuff.";
                                        room_info[6]="Dark windows look at you with a mixture of awe and threat.\n\nAs the witch saw the door open, she rushed into the house.\n";
                                        character[4][0]="7";//send the witch to the house
                                        action[4][0]="4";//and give her action back
                                        }
                                        else if(current_room!=6 && parameter1==3 && character[4][0]=="7"){//just to make sure the previous condition happened
                                        room_info[6]="Dark windows look at you with a mixture of awe and threat.";
                                        parameter1=0;//resetting parameter
                                        events[0]=0;
                                        }
                                        
                                        break;  
                            case 3:     //introducing Garlick Eater
                                        
                                        if(current_room!=5 && parameter1==0){
                                        character[5][0]="98";//removing garlick from the game
                                        character[6][0]="5";//putting Garlick Eater into room 5
                                        }
                                        else if(current_room==5 && character[6][0]=="5"){//if the Garlick Eater is in room 5
                                        
                                        parameter1=1;
                                        
                                        }
                                        else if(current_room==6 && parameter1==1){//if the Garlic Eater came and you saw him
                                        
                                        character[6][0]="6";//putting the Garlick Eater into room 6
                                        parameter1=2317;
                                        character[6][1]="\nPossibly because your pockets still smelled with garlick, the Garlick Eater has followed you. Accidentally it tripped over the chicken and fell on the witch house. The house went down with great noise and clouds of dust filled the air. When it became clear again, you saw that Garlick Eater ran away. The chicken did not seem to survive the event.";
                                        
                                        //Killing the chicken
                                        character[1][1]="";
                                        character[1][2]="0";
                                        character[1][3]="Dead chicken";
                                        
                                        //Killing the witch
                                        character[4][1]="You can also see a dead witch.";
                                        character[4][3]="Dead witch";
                                        action[4][0]="0";//removing witch action
                                        
                                        //changing house desription
                                        room_title[7]="Ruins of an old house";
                                        room_info[7]="Heaps of broken wood, garbage and pieces of various things. In the center stands the crushed pot. Masses of hot smoke curl above the place.";
                                        room_directions[7]="You can go left.";
                                        border_right=7;
                                        
                                        //changing room descriptions
                                        //room_title[6]="Near the ruins of an old house";
                                        room_info[6]="";
                                        room_directions[6]="Go left to visit the forest or go right to the ruins of the house.";
                                        
                                        room_info[5]="Old trees, cold wind and a lonely path. The skies above you are silent. You can also see ruins of an old house.";
                                        room_directions[5]="Go left to walk the path or go right to the ruins of the house.";
                                        
                                        //putting the coil into room 7
                                        character[7][0]="7";
                                        }
                                        else if(current_room!=6 && parameter1==2317){//if the Garlic Eater came and you saw him
                                        
                                        //changing backyard descriptions
                                        room_title[6]="Near the ruins of an old house";
                                        room_info[6]="The backyard now looks completely deserted and unkept.";
                                        room_directions[6]="Go left to visit the forest or go right to the ruins of the house.";
                                        
                                        //Putting chicken description
                                        character[1][1]="There is also a dead chicken here.";
                                        
                                        //removing Garlick Eater completely
                                        character[6][0]="98";
                                        
                                        parameter1=0;
                                        events[0]=0;
                                        }
                                        break;
                            case 4:     //the dwarf quest
                            
                                        character[8][0]=wxString::Format("%i",current_room);//making the dwarf follow you
                            
                                        if(current_room==4 && parameter1==1){
                                            character[8][1]="\nThe dwarf walks beside you.\n-What an idiotic tree, - he remarks.";
                                        }
                                        else if(current_room==5 && parameter1==1){
                                            character[8][1]="\nThe dwarf walks beside you.\n-What a stupid forest, - he remarks.";
                                        }
                                        else if(current_room==6 && parameter1==1){
                                            character[8][1]="\nThe dwarf walks beside you.\n-What a foolish backyard, - he remarks.";
                                        }
                                        else if(current_room==3 && parameter1==1){
                                            character[8][1]="\nThe dwarf walks beside you.\n-What a boring place, - he remarks.";
                                        }
                                        else if(current_room==7 && parameter1==1){
                                            parameter1=2;
                                            character[8][1]="\nThe dwarf looks around.\n-This is where we have to dig, - he remarks.";
                                            //so that we can't leave this room anymore
                                            border_left=7;
                                            border_right=7;
                                            room_directions[7]="";
                                            events[0]=0;
                                            parameter1=0;
                                        }
                            
                        }//switch
             
             
             
                }//going through all events

}//set event

//Find collectable
void TextGameFrm::FindCollectable(int current_room){

        //finding collectable characters which are in this room
        for(int i=0; i<max; i++){

          if(character[i][0]==wxString::Format("%i",current_room) && character[i][2]=="0"){
                bag[i]=i;
                character[i][0]="98";//removing the collectible from the room
                item_taken=true;//marking the flag             
            }//if character is in this room

        }//going through the character array

    }//find collectable

//check if bag is empty
bool TextGameFrm::BagIsEmpty(){

    for(int i=0;i<max;i++){
            if(bag[i]!=0){
            return false;
            }
    }//going through the bag    
    return true;
    }//bagisempty

//empty bag (inventory)
void TextGameFrm::EmptyBag(){
    for(int i=0;i<max;i++){
            bag[i]=0;
}
    }//emptybag

//Fill room info
void TextGameFrm::InitRooms(){

        room_title[3]="Inside the tree.";
        room_info[3]="It is totally dark here.";
        room_directions[3]="Go right to squeeze out of the tree.";

        room_title[4]="A weird tree.";
        room_info[4]="You see a huge tree with a hole in it. Music is heard from the hole.";
        room_directions[4]="Go left to squeeze yourself into the tree hole or go right and follow a path to the forest.";

        room_title[5]="In front of a forest.";
        room_info[5]="Old trees, cold wind and a lonely path. The skies above you are silent. You can also see an old house.";
        room_directions[5]="Go left to walk the path or go right to the house.";
        
        room_title[6]="Backyard of an old house.";
        room_info[6]="Dark windows look at you with a mixture of awe and threat.";
        room_directions[6]="Go left to visit the forest or go right into the house.";
        
        room_title[7]="Inside an old house.";
        room_info[7]="The house is small and very untidy. A large pot stands in the center of a room with some ooze boiling inside it. It fills the air with very bad smell. Right above the pot, attached to the ceiling with ropes, hangs a whole bunch of stuff.";
        room_directions[7]="Go left to exit the house or go right to the pot.";
        
        room_title[8]="Near the pot.";
        room_info[8]="You can see the ooze boil. What's worst - you can smell it even better.";
        room_directions[8]="You can go left.";
}

//Fill character info
void TextGameFrm::InitCharacters(){

        
        character[0][0]="4"; 
        character[0][1]="An Imaginary Owl sits on top of the tree.";
        character[0][2]="1";
        character[0][3]="Imaginary Owl";
        
        character[1][0]="6";
        character[1][1]="A rather agressive chicken approaches you.";
        character[1][2]="1";
        character[1][3]="Chicken";
        
        character[2][0]="8";
        character[2][1]="Above the pot hangs a seriously looking shotgun.";
        character[2][2]="0";
        character[2][3]="Broken shotgun";
        
        character[3][0]="4";
        character[3][1]="You can also see a cloak hanging from a tree.";
        character[3][2]="0";
        character[3][3]="Cloak";
        
        character[4][0]="7";
        character[4][1]="A witch stands by the pot and gives an occasinal stir to the ooze.";
        character[4][2]="1";
        character[4][3]="Witch";
        
        character[5][0]="8";
        character[5][1]="You also notice some garlick.";
        character[5][2]="0";
        character[5][3]="Garlick";
        
        character[6][0]="98";
        character[6][1]="\nA furry animal, the size of a building, slowly chews the garlick you dropped here earlier. Looking into the Stupid Text Games Guide, you learn that this must be the Garlick Eater. Obviously, it came from the forest.";
        character[6][2]="1";
        character[6][3]="Garlick Eater";
        
        character[7][0]="98";
        character[7][1]="Some coil glows under the crushed pot.";
        character[7][2]="0";
        character[7][3]="Piece of glowing coil";
        
        character[8][0]="98";
        character[8][1]="A dwarf sits there in the darkness. He looks tired and hungry. Beside him stands a radio which plays jazz.";
        character[8][2]="1";
        character[8][3]="Dwarf";
        
        character[9][0]="98";
        character[9][1]="A radio that plays jazz stands here.";
        character[9][2]="0";
        character[9][3]="Radio";
        
        character[10][0]="98";
        character[10][1]="A treasure chest stands in the center of the room.";
        character[10][2]="1";
        character[10][3]="Chest";
        
        action[0][0]="3";   action[0][1]="-Sorry. The restaurant is closed, - says the Imaginary Owl.\n";
        action[1][0]="2";   action[1][1]="The chicken performed a side kick and your head ended up several meters away from your body. What a disgrace!";
        action[2][0]="0";
        action[4][0]="4";   action[4][1]="The witch is in your way.";


}









void TextGameFrm::Death(){

        LeftButton->Enable(false);
        RightButton->Enable(false);
        UseButton->Enable(false);
        TakeButton->Enable(false);
        DropButton->Enable(false);
        dead=true;
        Screen->AppendText("\n\n\nTo start over press 'Enter'.");
}


//Use items
void TextGameFrm::UseItems(){

if(BagIsEmpty()==true){SetRoom(current_room);Screen->AppendText("\n\n\nNo items to use!");}
	else{
                    UseItemDlg dlg(this);
                     if ( dlg.ShowModal() ){

                                        if(item_chosen=="Broken shotgun"){
                                                if(current_room==4 && action[0][0]=="3"){
                                                action[0][0]="0";//setting the action to None
                                                character[0][0]="98";//removing the character from the room
                                                SetRoom(current_room);
                                                Screen->BeginItalic();
                                                Screen->AppendText("\n\nAn Imaginary Bullet whistled through the air and the Imaginary Owl vanished.");
                                                Screen->EndItalic();
                                                }
                                                else{SetRoom(current_room);Screen->AppendText("\n\nYou tried to shoot, but the broken shotgun just said Squak!");}
                                        }
                                        else if(item_chosen=="Cloak"){
                                                if(current_room==6 && action[1][0]=="2"){
                                                action[1][0]="0";//setting the action to None
                                                SetRoom(current_room);
                                                Screen->BeginItalic();
                                                Screen->AppendText("\n\nYou are cloaked! The chicken can't see you.");
                                                Screen->EndItalic();
                                                bag[3]=0;//removing the cloak from your bag
                                                character[1][1]="A rather agressive chicken wanders in front of the house, but it can't see you because you are cloaked.";
                                                }
                                                else{SetRoom(current_room);Screen->AppendText("\n\nThis does not seem to be the best idea at the moment.");}
                                        }
                                        else if(item_chosen=="Garlick"){
                                                SetRoom(current_room);Screen->AppendText("\n\nIf garlick can be useful at all, you think, then only by getting rid of it.");
                                        }
                                        else if(item_chosen=="Piece of glowing coil"){
                                                if(current_room==3){
                                                character[8][0]="3";//putting the dwarf into the tree
                                                room_info[3]="You find yourself in a tight room.";//changing tree description
                                                character[7][0]="3";//putting the coil into the room
                                                character[7][1]="Pieces of coil light up the tree hole with glow that sends weird shadows onto its walls.";
                                                character[7][2]="1";//making it unretrievable
                                                bag[7]=0;//removing from bag
                                                SetRoom(current_room);
                                                }
                                                else{
                                                    SetRoom(current_room);Screen->AppendText("\n\nYou decide there has to be a better idea.");
                                                    }
                                        }
                                        else if(item_chosen=="Dead chicken"){
                                                if(current_room==3 && character[7][0]=="3"){
                                                    SetRoom(current_room);
                                                    Screen->AppendText("\n\nYou could have offered it to the poor fellow, but it seems to you that if it is cooked the offer would be much more useful.");
                                                }
                                                else if(current_room==7){
                                                    character[1][1]="There is a roast chicken here.";
                                                    character[1][3]="Roast chicken";
                                                    SetRoom(current_room);
                                                    Screen->AppendText("\n\nYou decide to take advantage of the smoke above the ruins and cook the chicken.");
                                                }
                                                else{
                                                    SetRoom(current_room);Screen->AppendText("\n\nIf a dead chicken can help in this situation, you have no idea how.");
                                                    }
                                        }
                                        else if(item_chosen=="Roast chicken"){
                                                if(current_room==3 && character[7][0]=="3"){
                                                    SetRoom(current_room);
                                                    Screen->AppendText("\n\nThe dwarf is surprised that you decide to help him.");
                                                    Screen->AppendText("\n-Thank you, stranger. I haven't eaten in many days.");
                                                    Screen->AppendText("\nAfter having eaten, the dwarf looks at you again.");
                                                    Screen->AppendText("\n-How can I thank you?");
                                                    Screen->AppendText("\n-I love adventure, - you say. - I see you have a map. Are you in search of a mysterious treasure?");
                                                    Screen->AppendText("\n-In fact I am, but the task which lies before me seems to be greater than my powers. Several days ago I almost ended up becoming a rabbit.");
                                                    Screen->AppendText("\n-A rabbit?");
                                                    Screen->AppendText("\n-I am trying to dig out the Witch Chest under her house. But I cannot get even near it - the damn witch sniffs me out and then her chicken throws me out.");
                                                    Screen->AppendText("\n-Then I bring you good news - you say. - The chicken which you are so afraid of has just been eaten by you.");
                                                    Screen->AppendText("\nThe dwarf jumps to his feet in amazement.");
                                                    Screen->AppendText("\n-Indeed? Oh my, your contribution to this quest is so large that I must ask you to become my partner.");
                                                    Screen->AppendText("\n-It's a great honour. I accept.");
                                                    Screen->AppendText("\n-Great. I have eaten well and am ready. Let's go to the house and get our treasure!");
                                                    events[0]=4;//creating a new event
                                                    character[1][0]="98";//removing the chicken from the game (finally)
                                                    parameter1=1;
                                                    bag[1]=0;//removing the chicken from bag
                                                    bag[9]=9;//putting the radio into your inventory
                                                    room_info[4]="You see a huge tree with a hole in it.";               
                                                }
                                                else{
                                                    SetRoom(current_room);Screen->AppendText("\n\nIt doesn't seem to be of any use now.");
                                                }
                                        }
                                        else if(item_chosen=="Radio"){
                                        
                                            if(current_room==7){
                                                character[4][0]="98";//removing the witch
                                                room_title[7]="Under the ruins of an old house";
                                                room_info[7]="You put on the music and start working. After lots of digging you both find yourself in an underground chamber. The treasure chest stands in the center of the room.";
                                                character[8][1]="\nThe dwarf jumps in joy:\n-We have found the treasure! ";
                                                SetRoom(current_room);
                                                Screen->AppendText("\nDear player! Thank you for playing this humble text game.");
                                                Screen->AppendText("\nMore text games are planned in the future. Next planned release is a game based on Star Trek: Then Next Generation which I believe would be a more profound game than this first attempt.");
                                                Screen->AppendText("\n\nFor more fun stuff please visit www.louigiverona.ru");
                                            }
                                            else{SetRoom(current_room);Screen->AppendText("\n\nYou dig jazz!");}
                                        
                                        
                                        }
                    }//if dlg OK
    }

}//Use items


//Drop items
void TextGameFrm::DropItems(){

if(BagIsEmpty()==true){SetRoom(current_room);Screen->AppendText("\n\nNo items to drop!");}
	else{
                    UseItemDlg dlg(this);
                     if ( dlg.ShowModal() ){

                                        if(item_chosen=="Broken shotgun"){
                                                if(current_room==4 && action[0][0]=="3"){
                                                //do smth                                               
                                                }
                                                else{SetRoom(current_room);Screen->AppendText("\n\nThis might still be useful... though not necessarily. You can't make up your mind and just decide to keep the weapon.");}
                                        }
                                        else if(item_chosen=="Cloak"){
                                                SetRoom(current_room);Screen->AppendText("\n\nFunny how fast some things make one attached to them - you don't want to part with the cloak.");
                                        }
                                        else if(item_chosen=="Garlick"){
                                                if(current_room==5){
                                                character[5][0]="5";//putting the garlick into room 5
                                                bag[5]=0;//removing garlick from your bag
                                                events[0]=3;//set new event
                                                parameter1=0;
                                                SetRoom(current_room);
                                                }
                                                else{SetRoom(current_room);Screen->AppendText("\n\nYou feel this is not the right place to get rid of this thing.");}
                                        }
                                        else if(item_chosen=="Piece of glowing coil"){
                                                if(current_room==3){
                                                character[8][0]="3";//putting the dwarf into the tree
                                                room_info[3]="You find yourself in a tight room.";//changing tree description
                                                character[7][0]="3";//putting the coil into the room
                                                character[7][1]="Pieces of coil light up the tree hole with glow that sends weird shadows onto its walls.";
                                                character[7][2]="1";//making it unretrievable
                                                bag[7]=0;//removing from bag
                                                SetRoom(current_room);
                                                }
                                                else{
                                                    SetRoom(current_room);Screen->AppendText("\n\nYou decide there has to be a better idea.");
                                                    }
                                        }
                                        else if(item_chosen=="Dead chicken"){
                                                SetRoom(current_room);Screen->AppendText("\n\nYou decide to keep the chicken.");
                                        }
                                        else if(item_chosen=="Radio"){
                                                SetRoom(current_room);Screen->AppendText("\n\nYou will not throw out a gadget like that.");
                                        }
                    }//if dlg OK
    }

}//Drop items

/*
 * LeftButtonClick
 */
void TextGameFrm::LeftButtonClick(wxCommandEvent& event)
{
	if(action_flag[0][0]==3){//if you are being blocked to the left
	    SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[0][1]][1]);
        //LeftButton->Enable(false);
        }
        else if(action_flag[0][0]==1){//if you were killed trying to go left
        SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[0][1]][1]);
        Death();
        }
        else if(border_left==current_room){//if there is nothing to the left
        }
	else{
    current_room--;
    //RightButton->Enable(true);//if it was blocked in the previous room
	SetRoom(current_room);
	}
}

/*
 * RightButtonClick
 */
void TextGameFrm::RightButtonClick(wxCommandEvent& event)
{
	if(action_flag[1][0]==4){//if you are being blocked to the right
	    SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[1][1]][1]);
        //RightButton->Enable(false);
        }
        else if(action_flag[1][0]==2){//if you were killed trying to go right
        SetRoom(current_room);
        Screen->AppendText("\n\n");
        Screen->AppendText(action[action_flag[1][1]][1]);
        Death();
        }
        else if(border_right==current_room){//if there is nothing to the right
        }
	else{
	current_room++;
	//LeftButton->Enable(true);//if it was blocked in the previous room
	SetRoom(current_room);
    }
}

/*
 * Using items
 */
void TextGameFrm::NothingButtonClick(wxCommandEvent& event)
{
	UseItems();
}

/*
 * TakeButtonClick
 */
void TextGameFrm::TakeButtonClick(wxCommandEvent& event)
{
        FindCollectable(current_room);//find collectables, add them to the bag and remove from the room
            if(item_taken==true){
                    SetRoom(current_room);//reset the room
                    //Screen->AppendText("\n\nTaken!");
                    item_taken=false;
                    }
            else{SetRoom(current_room);Screen->AppendText("\nThere is nothing you can take here.");}
}

/*
 * DropButtonClick
 */
void TextGameFrm::DropButtonClick(wxCommandEvent& event)
{
	DropItems();
}
